 typedef signed char   int8; 
 typedef signed short  int16; 
 typedef signed long   int32; 
 typedef unsigned char  uint8; 
 typedef unsigned short  uint16; 
 typedef unsigned long  uint32; 

    /** BIt Defination ) ******************/

typedef union tag16FLAGS { 
    unsigned int asByte;        // allows access to the full 16 bits 
    struct tag16BITS { 
  unsigned b0:1;    
  unsigned b1:1;    
  unsigned b2:1;    
  unsigned b3:1;
  unsigned b4:1;  
  unsigned b5:1;    
  unsigned b6:1;
  unsigned b7:1;
  unsigned b8:1;    
  unsigned b9:1;    
  unsigned b10:1;    
  unsigned b11:1;
  unsigned b12:1;  
  unsigned b13:1;    
  unsigned b14:1;
  unsigned b15:1;    
    }; 
} T16_FLAGS; 



typedef union tag8FLAGS { 
    unsigned char asByte;        // allows access to the full 8 bits 
    struct tag8BITS { 
  unsigned b0:1;    
  unsigned b1:1;    
  unsigned b2:1;    
  unsigned b3:1;
  unsigned b4:1;  
  unsigned b5:1;    
  unsigned b6:1;
  unsigned b7:1;
    }; 
} T8_FLAGS; 


T8_FLAGS Flags;
T8_FLAGS Flags2;
T8_FLAGS Flags3;
T8_FLAGS Flags4;
T8_FLAGS computeByte;
T8_FLAGS cycleByte;


#if defined(__18F4550)
T8_FLAGS  FrameFirst; 
T8_FLAGS  RedFlags; 
T8_FLAGS  GreenFlags; 
T8_FLAGS  BlueFlags; 
T8_FLAGS  CycleFlags; 
T8_FLAGS MultiSwap; 
T8_FLAGS MultiStall;
#elif defined(__18F2550)
//need to be 16 bit wide
T16_FLAGS  FrameFirst; 
T16_FLAGS  RedFlags; 
T16_FLAGS  GreenFlags; 
T16_FLAGS  BlueFlags; 
T16_FLAGS  CycleFlags; 
T16_FLAGS MultiSwap;
T16_FLAGS MultiStall;
#endif


#define Flag1 Flags.b0
#define Flag2  Flags.b1
#define MultiUploadFlag Flags.b2
#define FlagCmdLiveUpload Flags.b3
#define FlagCmdPatternNum Flags.b4
#define FlagCmdUpload Flags.b5
#define DeviceConnected Flags.b6
#define LiveMode Flags.b7

#define FlagRestartPatt Flags2.b0
#define FlagPauseCycle Flags2.b1
#define DataConfirm Flags2.b2
#define MultiRollOver Flags2.b3
#define SetMultiFlag Flags2.b4
#define MultiFlag Flags2.b5
#define MultiHOLD Flags2.b6
#define FillArrays Flags2.b7


#define RandomColors Flags3.b0
#define ChangeFlag Flags3.b1
#define DemoMode Flags3.b2
#define FlagSettingUpload Flags3.b3
#define SettingsFirst Flags3.b4
#define DemoUpload Flags3.b5
#define SlideFirst Flags3.b6
#define WasLive Flags3.b7


//byte = Rdir - Gdir - Bdir - Rf - Gf - Bf - 0 - 0
#define SpBit2 cycleByte.b0
#define SpBit1 cycleByte.b1
#define Bflag cycleByte.b2
#define Gflag cycleByte.b3
#define Rflag cycleByte.b4
#define Bdir cycleByte.b5
#define Gdir cycleByte.b6
#define Rdir cycleByte.b7

#define cSpBit2 computeByte.b0
#define cSpBit1 computeByte.b1
#define cBflag computeByte.b2
#define cGflag computeByte.b3
#define cRflag computeByte.b4
#define cBdir computeByte.b5
#define cGdir computeByte.b6
#define cRdir computeByte.b7



#define waitingForXLAT Flags4.b1
#define updatePending Flags4.b2
#define ToggleFlag Flags4.b3
#define BounceFlag Flags4.b4
#define PackTheData Flags4.b5

#pragma idata sect0=0x060 //3 registers left

	char USB_Out_Buffer[CDC_DATA_OUT_EP_SIZE]=
{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3};


	unsigned char  NextUSBOut=0;


	unsigned char LEDnum = 0;
	unsigned char x;
	unsigned char q;
	unsigned char NewBuffer = 0;
	unsigned char nextFrameVar= 0;
	unsigned char PatternMax=0;
	unsigned char PWMPeriod = 0;
	unsigned char uploadCounter =0;
	unsigned char uploadRollover=0;
	unsigned char TempFrame=0;
	

	unsigned char CurrentFrameRStart = 0;
	unsigned char CurrentFrameREnd = 0;
	unsigned char CurrentFrameGStart = 0;
	unsigned char CurrentFrameGEnd = 0;
	unsigned char CurrentFrameBStart = 0;
	unsigned char CurrentFrameBEnd = 0;

	int CycleTimer=10; // was short long = -8,388,608 to 8,388,607
	int CycleTimerHold=10;

	unsigned char Mode = 0;

	unsigned char SwCount = 1;

	unsigned char Buffer1=0;
	unsigned char Buffer2=0;
	unsigned char Buffer3=0;
	
	
	unsigned char DataSkip=0;
	unsigned char DataPart=0;

	unsigned char FrameNumber=0;
	unsigned char FrameAmount=2; 

	unsigned char FrameVar[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //what frame, color to color

	unsigned char PatternNum[]={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

//USE THIS DATA SPACE
//	unsigned char CycleCounter[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //counts the cycles

	unsigned char MultiCounter[]={ 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char MultiPattern[]={ 0, 0, 0, 0, 0, 0, 0, 0};

	unsigned char FrameByteArray[]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //holds direction data for each LED channel

	unsigned char TempRed=0;

	unsigned char SlideHold;//=0;

#pragma idata sect1=0x100

	unsigned char SendArray[]={0, 0, 0, 0, 0, 0, 0, 0}; //variables for sending RAM data

	unsigned char uploadStr[72];//={3};
//{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3};

//Variables for each LED use for array lookups

	int MathValR=0;
	int MathValG=0;
	int MathValB=0;
	int i=0;

	unsigned short FlashAddress= 1;

	unsigned char SetNumber = 1;

	unsigned char tempType=0;

	unsigned char tempMode=0;

	unsigned char SettingC=1;

	unsigned char TestVar = 10;

	unsigned char MultiHoldCount=0;
	unsigned char MultiNext=0;
	unsigned char MultiPattNum=0;

	unsigned char byteCounter=0;//for TLC version

	unsigned char SetSelection=0;

	unsigned char RandomPatternRStart[] = {0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char RandomPatternGStart[] = {0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char RandomPatternBStart[] = {0, 0, 0, 0, 0, 0, 0, 0};

	unsigned char RandomPatternREnd[] = {0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char RandomPatternGEnd[] = {0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char RandomPatternBEnd[] = {0, 0, 0, 0, 0, 0, 0, 0};

	unsigned char RandomMaxFrame= 2;

#pragma udata sect2=0x200
	char input_buffer[16]; //this is put wherever
	
	unsigned char RedVal[16];//[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //goes into RAM registers same as 
	unsigned char GreenVal[16];//l[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //goes into RAM registers same as 
	unsigned char BlueVal[16];//[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //goes into RAM registers same as 

	float  FloatRFactor[16];//[]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0  }; //192 bytes!!!
	float  FloatGFactor[16];//[]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }; //2x = 128
	float  FloatBFactor[16];//][]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }; //64

//#pragma idata sect3=0x300 //used for stack

#pragma udata sect5=0x700 //FULL!

	unsigned char RedHoldVal[16];//[] = {0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char GreenHoldVal[16];//[] ={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char BlueHoldVal[16];//[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

	float  CycleFactorG[16];//[]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }; //64
	float  CycleFactorB[16];//[]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };//64
	float  CycleFactorR[16];//[]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };//64 = 256
	
#pragma idata sect6=0x600 

	unsigned char TempGreen=0;
	unsigned char TempBlue=0;	

	unsigned char FrameData[64] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

//	unsigned char DotCorrection[48]={0}; //holds the dot correction data to be sent on startup, it is set in main()
//  this space is required, maybe fill packedGreyScale will DotCorrection values since its only used at startup!!!

	unsigned char packedGreyScale[72]={0}; //holds the data to be sent after its been expanded from 8-bit to 12-bit number

	int bitCounter=0; //variable for for loop
	int GSCLK_Counter=0;
	int DATA_Counter=0;

	unsigned char SlideBytes[] ={0, 0, 0, 0, 0, 0, 0, 0};
//FrameR1[1-16][1-8] - FrameG1[1-16][1-8] - FrameB1[1-16][1-8] - Speed[1-8] - FrameAmount = 393 bytes

//with SlideBytes = 401

#pragma romdata MultiSettigns=0x7180

	rom unsigned char MultiPatternHold[4][8]={ {5, 1, 2, 8, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0} };
	rom unsigned char MultiCounterHold[4][8]={ {4, 2, 3, 3, 4, 4, 2, 2}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, { 0, 0, 0, 0, 0, 0, 0, 0} };


#pragma romdata Settings2=0x71C0//0x7500


#if defined(__18F4550)

const rom unsigned char BtChk[] = { 0b00000001,0b00000010,0b00000100,0b00001000,
0b00010000,0b00100000,0b01000000,0b10000000 };
const rom unsigned char LEDTotal=8;
const rom unsigned char LEDTotalm=7;

#elif defined(__18F2550)

const rom unsigned char LEDTotal=16;
const rom unsigned char LEDTotalm=15;


const rom unsigned int BtChk[] = { 
0b0000000000000001,0b0000000000000010,0b0000000000000100,0b0000000000001000,
0b0000000000010000,0b0000000000100000,0b0000000001000000,0b0000000010000000,
0b0000000100000000,0b0000001000000000,0b0000010000000000,0b0000100000000000,
0b0001000000000000,0b0010000000000000,0b0100000000000000,0b1000000000000000};
#endif


const rom unsigned short AddressSetF1[]={0x7280,0x72C0,0x7300,0x7340,0x7380,0x73C0,0x7400};
const rom unsigned short AddressSetF2[]={0x7440,0x7480,0x74C0,0x7500,0x7540,0x7580,0x75C0};
const rom unsigned short AddressSetF3[]={0x7600,0x7640,0x7680,0x76C0,0x7700,0x7740,0x7780};
const rom unsigned short AddressSetF4[]={0x77C0,0x7800,0x7840,0x7880,0x78C0,0x7900,0x7940};

const rom unsigned short AddressSetFDemo[]={0x7980,0x79C0,0x7A00,0x7A40,0x7A80,0x7AC0,0x7B00};

const rom unsigned short AddressSetC1[]={0x7B40,0x7B80};
const rom unsigned short AddressSetC2[]={0x7BC0,0x7C00};
const rom unsigned short AddressSetC3[]={0x7C40,0x7C80};
const rom unsigned short AddressSetC4[]={0x7CC0,0x7D00};
const rom unsigned short AddressSetC5[]={0x7D40,0x7D80};
const rom unsigned short AddressSetC6[]={0x7DC0,0x7E00};
const rom unsigned short AddressSetC7[]={0x7E40,0x7E80};
const rom unsigned short AddressSetC8[]={0x7EC0,0x7F00};

const rom unsigned short AddressSetCDemo[]={0x7F40,0x7F80};

const rom unsigned char SetTypes[]={7,7,7,7,2,2,2,2,2,2,2,2}; //10 values


#pragma romdata memFlash1=0x7280
//Pattern 1 - Red - Yellow - Green - Teal -  Blue - Purple -
//				1		2		3		4		5		6

rom unsigned char Flash1A[192]={
0, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
};

rom unsigned char Flash1B[192]={
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255
};

// 0x7400

rom unsigned char Flash1Speeds[]={20, 20, 10, 10, 10, 10, 10, 10};
rom unsigned char Flash1FraAmt=1;
rom unsigned char Flash1Slides[]={32, 17, 32, 32, 32, 32, 32, 32};

rom unsigned char Dummy1[47]={0x33};

#pragma romdata memFlash2=0x7440

rom unsigned char Flash2A[192]={
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,

255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,
};

rom unsigned char Flash2B[192]={
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,

0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,
0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,
0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,

255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,
255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,
255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,

0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255}; 

rom unsigned char Flash2Speeds[]={10, 10, 10, 10, 10, 10, 10, 10};

rom unsigned char Flash2FraAmt=3;
rom unsigned char Flash2Slides[]={32, 32, 32, 32, 32, 32, 32, 32};

rom unsigned char Dummy2[47]={0x33};

#pragma romdata memFlash3=0x7600

rom unsigned char Flash3A[192]={
255, 0, 255, 0, 255, 0, 255, 0, 255, 0, 255, 0, 255, 0, 255, 0,
255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,
255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,

0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,

0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,
0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,
0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,

255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,
255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,
255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,
};

rom unsigned char Flash3B[192]={
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0, 255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0, 255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0, 255,

0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,
0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,
0, 0, 255, 255, 0, 0, 255, 255,0, 0, 255, 255, 0, 0, 255, 255,

255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,
255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,
255, 0, 255, 0, 255, 0, 255, 0,255, 0, 255, 0, 255, 0, 255, 0,

0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255,
0, 255, 0, 255, 0, 255, 0,255,0, 255, 0, 255, 0, 255, 0,255}; 

rom unsigned char Flash3Speeds[]={20, 20, 20, 20, 20, 20, 20, 20};
rom unsigned char Flash3FraAmt=3;

rom unsigned char Flash3Slides[]={32, 32, 32, 32, 32, 32, 32, 32};

rom unsigned char Dummy3[47]={0x33};

#pragma romdata memFlash4=0x77C0

rom unsigned char Flash4A[192]={
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0 ,0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0 ,0, 0, 0, 0, 0, 0, 0, 0, 

255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
};

rom unsigned char Flash4B[192]={
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255
};

rom unsigned char Flash4Speeds[]={10, 20, 10, 20, 10, 20, 10, 20};
rom unsigned char Flash4FraAmt=2;
rom unsigned char Flash4Slides[]={32, 32, 32, 32, 32, 32, 32, 32};

rom unsigned char Dummy4[47]={0x33};


#pragma romdata memFlashDemo=0x7980

rom unsigned char FlashDemoA[192]={
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0 ,0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0 ,0, 0, 0, 0, 0, 0, 0, 0, 

255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
};

rom unsigned char FlashDemoB[192]={
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255
};

// 0x7B00

rom unsigned char FlashDemoSpeeds[]={20, 20, 20, 20, 20, 20, 20, 20};
rom unsigned char FlashDemoFraAmt=2;
rom unsigned char FlashDemoSlides[]={32, 32, 32, 32, 32, 32, 32, 32};
rom unsigned char DummyDemo[47]={0x33};

// Flash Space = 2240 bytes or 35 64 byte sections
// Fade = 1152 or 18 64 byte sections
 
//12992

// ColorR[16] - ColorG[16] - ColorB[16] - StartValR[16] - StartValG[16] - StartValB[16] - FrameVar[16] - Type - Speed - Amount - 
// = 115 bytes

#pragma romdata Patt1=0x7B40

//16 LED full color
rom unsigned char Pattern1RStartVal[] = {255	,0,0	,0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0};
rom unsigned char Pattern1GStartVal[] ={0,255,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0};
rom unsigned char Pattern1BStartVal[] = {0,	0,	255	,0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0};
rom unsigned char Pattern1RHold[] ={255,	208,	161,	114	,67,20,	20,	20,	20,	20,	20,	7,	54,	101	,148,	195};//{255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255};
rom unsigned char Pattern1GHold[] ={0,	47	,94,	141	,188,	235	,228,	181,	134,	87,	40,	40,	40	,40,	40,	40};// {0, 63, 126, 189, 252, 195, 132, 69, 0, 63, 126, 189, 252, 195, 132, 69};
rom unsigned char Pattern1BHold[] ={0,	0,	0,	0,	0,	0,	27,	74,	121,	168	,215,	248	,201,	154,	107	,60};// {255, 192, 129, 66, 3, 60, 123, 186, 255, 192, 129, 66, 3, 60, 123, 186};
rom unsigned char Pattern1FrameVar[]={0,	0,	0,	0,	0,	0, 1	,1,	1,	1,	1,	2,	2,	2,	2,	2};// {0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1};
rom unsigned char Pattern1Type=0;
rom unsigned char Pattern1Speed=2;
rom unsigned char Pattern1MaxFrame= 2;

rom unsigned char Dummy5[13]={0x33};

#pragma romdata Patt2=0x7BC0

//pruple blue
rom rom unsigned char Pattern2RStartVal[] = {0, 73, 127, 0,0,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern2GStartVal[] = {255, 147, 255, 0,255,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern2BStartVal[] = {0, 0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern2RHold[] ={0, 13, 27, 40, 54, 67, 79, 89, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern2GHold[] = {255, 235, 215, 195, 175, 155, 158, 178, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern2BHold[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern2FrameVar[]= {0, 0, 0, 0, 0, 0, 1, 1,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern2Type=0;
rom rom unsigned char Pattern2Speed=1;
rom rom unsigned char Pattern2MaxFrame= 1;


rom unsigned char Dummy6[13]={0x33};

#pragma romdata Patt3=0x7C40
//redish
rom rom unsigned char Pattern3RStartVal[] = {255, 255, 0, 0,0,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern3GStartVal[] = {0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern3BStartVal[] = {255, 0, 0, 0,255,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern3RHold[] ={255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern3GHold[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern3BHold[] = {255, 192, 129, 66, 3, 60, 123, 186, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern3FrameVar[]= {0, 0, 0, 0, 0, 1, 1, 1,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern3Type=0;
rom rom unsigned char Pattern3Speed=4;
rom rom unsigned char Pattern3MaxFrame= 1;

rom unsigned char Dummy7[13]={0x33};

#pragma romdata Patt4=0x7CC0
//redish -swapped red for green
rom rom unsigned char Pattern4RStartVal[] = {0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern4GStartVal[] = {255, 255, 0, 0,0,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern4BStartVal[] = {255, 0, 0, 0,255,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern4RHold[] ={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern4GHold[] = {255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern4BHold[] = {255, 192, 129, 66, 3, 60, 123, 186, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern4FrameVar[]= {0, 0, 0, 0, 0, 1, 1, 1,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern4Type=0;
rom rom unsigned char Pattern4Speed=10;
rom rom unsigned char Pattern4MaxFrame= 1;

rom unsigned char Dummy8[13]={0x33};

#pragma romdata Patt5=0x7D40
//solid
rom rom unsigned char Pattern5RStartVal[] = {255, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern5GStartVal[] = {0, 255, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern5BStartVal[] = {0, 0, 255, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern5RHold[] ={255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255};
rom rom unsigned char Pattern5GHold[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern5BHold[] = {0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern5FrameVar[]= {0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern5Type=0;
rom rom unsigned char Pattern5Speed=1;
rom rom unsigned char Pattern5MaxFrame= 2;

rom unsigned char Dummy9[13]={0x33};

#pragma romdata Patt6=0x7DC0
//redish
rom rom unsigned char Pattern6RStartVal[] = {255, 255, 0, 0,0,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern6GStartVal[] = {0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern6BStartVal[] = {255, 0, 0, 0,255,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern6RHold[] ={255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern6GHold[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern6BHold[] = {255, 192, 129, 66, 3, 60, 123, 186, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern6FrameVar[]= {0, 0, 0, 0, 0, 1, 1, 1,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern6Type=0;
rom rom unsigned char Pattern6Speed=40;
rom rom unsigned char Pattern6MaxFrame= 1;

rom unsigned char Dummy10[13]={0x33};

#pragma romdata Patt7=0x7E40
//redish
rom rom unsigned char Pattern7RStartVal[] = {255, 255, 0, 0,0,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern7GStartVal[] = {0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern7BStartVal[] = {255, 0, 0, 0,255,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern7RHold[] ={255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern7GHold[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern7BHold[] = {255, 192, 129, 66, 3, 60, 123, 186, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern7FrameVar[]= {0, 0, 0, 0, 0, 1, 1, 1,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern7Type=0;
rom rom unsigned char Pattern7Speed=1;
rom rom unsigned char Pattern7MaxFrame= 1;

rom unsigned char Dummy11[13]={0x33};

#pragma romdata Patt8=0x7EC0
//redish
rom rom unsigned char Pattern8RStartVal[] = {0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern8GStartVal[] = {255, 255, 0, 0,0,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern8BStartVal[] = {255, 0, 0, 0,255,255,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern8RHold[] ={255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern8GHold[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern8BHold[] = {255, 192, 129, 66, 3, 60, 123, 186, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char Pattern8FrameVar[]= {0, 0, 0, 0, 0, 1, 1, 1,0,0,0,0,0,0,0,0};
rom rom unsigned char Pattern8Type=0;
rom rom unsigned char Pattern8Speed=10;
rom rom unsigned char Pattern8MaxFrame= 1;

rom unsigned char Dummy12[13]={0x33};


#pragma romdata PattDemo=0x7F40
//redish
rom rom unsigned char PatternDemoRStartVal[] = {255, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char PatternDemoGStartVal[] = {0, 255, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char PatternDemoBStartVal[] = {0, 0, 255, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char PatternDemoRHold[] ={255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255};
rom rom unsigned char PatternDemoGHold[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
rom rom unsigned char PatternDemoBHold[] = {0, 0, 0, 0,0,0,0,0,0,0,0,0,0,0,0,0};
rom rom unsigned char PatternDemoFrameVar[]= {0, 0, 0, 0, 0, 1, 1, 1,0,0,0,0,0,0,0,0};
rom rom unsigned char PatternDemoType=0;
rom rom unsigned char PatternDemoSpeed=2;
rom rom unsigned char PatternDemoMaxFrame= 2;

rom unsigned char DummyCDemo[13]={0x33};


#pragma romdata Settings1=0x7FC0

	rom unsigned char RefID[12]={13,9,1,2,3,12,0,0,0,0,0,0}; //write to EEPROM
	rom unsigned char MaxSettings=5;//write to EEPROM

	rom unsigned char Dummy13[51]={0x33};
